unit HK;{procedures against hacker Copyright (C) BTI}
 Unit description:
 Except if specified, procedures are independent
 (you can invert them and/or not use them)

 types & constants:
 ------------------
 integer  : 2 octets signed [-32768,32767]
 longint  : 4 octets signed [-2147483648,2147473647]
 byte     : 1 octet unsigned [0,255]
 word     : 2 octets unsigned [0,65535]
 char     : 1 octet [#0,#255] (a character)
 pchar    : 4 octets (pointer on string A Zero Terminal)
 string   : 1 octet in start (contains string length) + 1 by char.
	    (string limited from 0 to 255 characters)

 Parameters are passed by value (variables are backup) except if they are
 preceded by the word 'var' (passed by variable: it's the address of the
 parameter that is transmitted).

 If you use the String Pascal convention (fct dll2xxx), always pass
 the string by value (ignore the word 'var'). In this convention, it's
 always the string parameter address that is passed.

 variables:
 ---------
 td    = chronometer start time
 tf    = chronometer final time
 delta = maximum execution delay authorized (in seconds)
 chem  = DOS path for the ASCII or binary file to use

 functions (all):
 ----------------
procedure about;{KD version number}

 functions (units only):
 -----------------------
procedure encryptstr(var s:string;Key:word;nbpass:integer);{string code/uncode}
procedure lockey;{lock keyboard}
procedure unlockey;{unlock keyboard}
procedure blackout(da:word);{crash system}
procedure delai(ms:longint);{pause system (ms=delay very approx in millisec)}
function debuger:integer;{->1ifExist,0ifNot}
procedure stopdebuger;{start test anti-debug:crash if detected (sf win32)}
function timer_on:longint;{->td=start time (retrieve present time)}
function timer_off(td,delta:longint):integer;{->1 if debuger: tf-td>delta (sec)}
function getfilecrc(chem:string):longint;{->compute CRC of chem (or -1) (3sec/1.5Mo)}
function getfilechk(chem:string):longint;{->CRC store in chem (or -1)}

 functions (dll convention Pchar Windows):
 ----------------------------------------
procedure dllencryptstr(var s:pchar;Key:word;nbpass:integer);{string code/uncode}
procedure dlllockey;{lock keyboard}
procedure dllunlockey;{unlock keyboard}
procedure dllblackout(da:word);{crash system}
procedure dlldelai(ms:longint);{pause system (ms=delay very approx in millisec)}
function dlldebuger:integer;{->1ifExist,0ifNot}
procedure dllstopdebuger;{start test anti-debug:halt if detected (sf win32)}
function dlltimer_on:longint;{->td=start time (retrieve present time)}
function dlltimer_off(td,delta:longint):integer;{->1 if debuger: tf-td>delta (sec)}
function dllgetfilecrc(chem:pchar):longint;{->compute CRC of chem (or -1) (3sec/1.5Mo)}
function dllgetfilechk(chem:pchar):longint;{->CRC store in chem (or -1)}

 functions (dll convention String Pascal): for VB3
 ----------------------------------------

procedure dll2encryptstr(var s:string;Key:word;nbpass:integer);{string code/uncode}
function dll2getfilecrc(chem:string):longint;{->compute CRC of chem (or -1) (3sec/1.5Mo)}
function dll2getfilechk(chem:string):longint;{->CRC store in chem (or -1)}


 error codes & explanations:
 -------------------------------
procedure encryptstr(var s:string;Key:word;nbpass:integer);{string code/uncode}
{crypt/uncrypt a text 's' with a pass number 'nbpass' and a key 'key'}
{retrieve in 's' the crypted/uncrypted text (same number of character)}
{uncrypt if the text is crypted, and inversely}
{note: the text 's' is limited to 255 characters, nbpass is <=255}

procedure lockey;{lock keyboard} assembler;
{block up the keyboard (forbid the use of the keyboard)}

procedure unlockey;{unlock keyboard}
{free the keyboard (authorize again the use)}

procedure blackout(da:word);{crash system}
{crash your computer (debuger post-mortem impossible)}
{parameter 'da' "disturb" the hacker (not modifies the execution speed)}

procedure delai(ms:longint);{pause system (ms=delay very approx in millisec)}
{block the system for appreciatively "ms" milliseconds}
{this can "distrub" the hacker}

function debuger:integer;{->1ifExist,0ifNot}
{retrieve 1 if a debuger is detected (uses it in different places)}
{note: retrieve 0 with the integrated debugers (BP7, Delphi...)}

procedure stopdebuger;{start test anti-debug:crash if detected (sf win32)}
{run the test anti-debug, crash the system if a debuger is present}
{WARNING: use it only ONE time (at the beginning)}

function timer_on:longint;{->td=start time (retrieve present time)}
{dependance: use it before timer_off}

function timer_off(td,delta:longint):integer;{->1 if debuger: tf-td>delta (sec)}
{retrieve 1 if the execution time since "td" is longer to "delta" millisecs}
{if it's the case, a debuger is probably present}
{WARNING: EVALUATE CAREFULLY THE MAXIMUM EXECUTION TIME NECESSARY}
{dependance: use it after timer_on}

function getfilecrc(chem:string):longint;{->compute CRC of chem (or -1) (3sec/1.5Mo)}
{compute a check sum on ASCII/bin file (-> -1 if not find)}
{with this test, yours applications integrity is guaranteed}

function getfilechk(chem:string):longint;{->CRC store in chem (or -1)}
{read the check sum stocked in chem (-> -1 if not find)}
{if getfilecrc<>getfilechk yours application is corrupted}
{USE: necessary because it's impossible to save the check sum in the
      executable itself}
{WARNING: don't touch the files you want to control}
{ex: by storage in the executable of configuration parameters}


{*fin*}
end.



